<mat-sidenav-container autosize class="maarch-container">
    <mat-sidenav-content>
        <div class="bg-head">
            <div class="bg-head-title" [class.customContainerRight]="appService.getViewMode()">
                <div class="bg-head-title-label">
                    <header-left></header-left>
                </div>
                <div class="bg-head-title-tool">
                    <header-right></header-right>
                </div>
            </div>
            <div class="bg-head-content" [class.fullContainer]="appService.getViewMode()">
            </div>
        </div>
        <div class="container" [class.fullContainer]="appService.getViewMode()">
            <div class="container-content">
                <div *ngIf="loading" style="display:flex;height:100%;">
                    <mat-spinner style="margin:auto;"></mat-spinner>
                </div>
                <mat-card *ngIf="!loading" class="card-app-content">
                    <div *ngIf="action.is_system == true" class="alert alert-danger" role="alert">
                        <b>{{'lang.isSytemAction' | translate}} !</b> {{'lang.doNotModifyUnlessExpert' | translate}}
                    </div>
                    <form class="form-horizontal" (ngSubmit)="onSubmit()" #actionsFormUp="ngForm">
                        <div class="form-group">
                            <div class="col-sm-12">
                                <mat-form-field>
                                    <input matInput [(ngModel)]="action.label_action" required name="action_name"
                                        id="action_name" title="{{'lang.label' | translate}}" type="text"
                                        placeholder="{{'lang.label' | translate}}" maxlength="255">
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-sm-12">
                                <plugin-select-search [showLabel]="true" [class]="''"
                                    [label]="'lang.actionCarriedOut' | translate"
                                    [placeholderLabel]="'lang.actionCarriedOut' | translate"
                                    [formControlSelect]="selectActionPageId" [datas]="actionPages"
                                    [optGroupList]="group" [optGroupTarget]="'category'" (afterSelected)="getCustomFields()" style="width:100%;">
                                </plugin-select-search>
                            </div>
                        </div>

                        <!-- EDISSYUM - NCH01 Ajout d'une option pour autoriser ou non la validation du viseur ou du signataire courant avant envoi au parapheur externe -->
                        <div class="form-group" *ngIf="action.actionPageId=='sendToExternalSignatureBook'">
                            <div class="col-sm-12">
                                <plugin-select-search [showLabel]="true" [class]="''"
                                                      [label]="'lang.visaValidation' | translate"
                                                      [placeholderLabel]="'lang.visaValidation' | translate"
                                                      [formControlSelect]="this.visaValidation" [datas]="visaChoice"
                                                      style="width:100%;">
                                </plugin-select-search>
                            </div>
                        </div>
                        <!-- END EDISSYUM - NCH01 -->

                        <div class="form-group"
                            *ngIf="!this.functions.empty(availableCustomFields) && action.actionPageId=='close_mail'">
                            <div class="col-sm-12">
                                <plugin-select-search [showLabel]="true" [class]="''"
                                    [label]="'lang.checkEmptyFields' | translate"
                                    [placeholderLabel]="'lang.checkEmptyFields' | translate"
                                    [formControlSelect]="customFieldsFormControl" [datas]="availableCustomFields"
                                    (afterSelected)="getSelectedFields()" style="width:100%;">
                                </plugin-select-search>
                                <mat-chip-list class="checkbox-selected-list">
                                    <mat-chip *ngFor="let fieldValue of selectedFieldsValue; let i = index" selected
                                        [removable]="true" (removed)="removeSelectedFields(i)">
                                        {{fieldValue}}
                                        <mat-icon matChipRemove class="fa fa-times-circle"></mat-icon>
                                    </mat-chip>
                                </mat-chip-list>
                            </div>
                        </div>
                        <div class="form-group" *ngIf="intermediateStatusActions.indexOf(action.actionPageId) !== -1">
                            <div *ngIf="action.actionPageId === 'send_shipping'" class="col-sm-6">
                                <plugin-select-search [showLabel]="true" [class]="''" [title]="'lang.intermediateStatus' | translate"
                                                      [label]="'lang.intermediateStatus' | translate"
                                                      [placeholderLabel]="'lang.intermediateStatus' | translate"
                                                      [formControlSelect]="selectIntermidiateStatusId" [datas]="statuses"
                                                      (afterSelected)="intermediateStatus = selectIntermidiateStatusId.value" style="width:100%;" [required]="true">
                                </plugin-select-search>
                            </div>
                            <!-- Maileva status -->
                            <div *ngIf="action.actionPageId === 'send_shipping'"  class="col-sm-6">
                                <app-select-with-filter #intermediateStatus [required]="true"
                                    name="linkedIntermediateStatus" [label]="'lang.mailevaStatus' | translate"
                                    [(ngModel)]="intermediateSelectedStatus" [array]="intermediateStatusParams.data" [multiple]="true" (selectionChange)="getSelectedStatus($event, 'intermediateStatus')">
                                </app-select-with-filter>
                            </div>
                            <!--  -->
                            <div [class]="action.actionPageId === 'send_shipping' ? 'col-sm-6' : 'col-sm-12'">
                                <plugin-select-search [showLabel]="true" [class]="''" [title]="'lang.finalStatusAlt' | translate"
                                                      [label]="'lang.finalStatus' | translate"
                                                      [placeholderLabel]="'lang.finalStatusAlt' | translate"
                                                      [formControlSelect]="selectSuccessStatusId" [datas]="statuses"
                                                      (afterSelected)="successStatus = selectSuccessStatusId.value" style="width:100%;" [required]="true">
                                </plugin-select-search>
                            </div>
                            <!-- Maileva status -->
                            <div *ngIf="action.actionPageId === 'send_shipping'"  class="col-sm-6">
                                <app-select-with-filter #finalStatus [required]="true"
                                    name="linkedFinalStatus" [label]="'lang.mailevaStatus' | translate"
                                    [(ngModel)]="finalSelectedStatus" [array]="finalStatusParams.data" [multiple]="true" (selectionChange)="getSelectedStatus($event, 'finalStatus')">
                                </app-select-with-filter>
                            </div>
                            <!--  -->
                            <div [class]="action.actionPageId === 'send_shipping' ? 'col-sm-6' : 'col-sm-12'">
                                <plugin-select-search [showLabel]="true" [class]="''" [title]="'lang.errorStatusAlt' | translate"
                                                      [label]="'lang.errorStatus' | translate"
                                                      [placeholderLabel]="'lang.errorStatusAlt' | translate"
                                                      [formControlSelect]="selectErrorStatusId" [datas]="statuses"
                                                      (afterSelected)="errorStatus = selectErrorStatusId.value" style="width:100%;" [required]="true">
                                </plugin-select-search>
                            </div>
                            <!-- Maileva status -->
                            <div *ngIf="action.actionPageId === 'send_shipping'"  class="col-sm-6">
                                <app-select-with-filter #errorStatus [required]="true"
                                    name="linkedErrorStatus" [label]="'lang.mailevaStatus' | translate"
                                    [(ngModel)]="errorSelectedStatus" [array]="errorStatusParams.data" [multiple]="true" (selectionChange)="getSelectedStatus($event, 'errorStatus')">
                                </app-select-with-filter>
                            </div>
                            <!--  -->
                            <em class="col-sm-12" *ngIf="action.actionPageId !== 'sendToRecordManagement'">{{'lang.intermediateStatusMailing' | translate}}</em>
                        </div>
                        <div class="form-group" *ngIf="action.actionPageId=='create_acknowledgement_receipt'">
                            <div class="col-sm-12">
                                <mat-form-field>
                                    <mat-select [required]="action.actionPageId=='create_acknowledgement_receipt'"
                                        id="generateARmode" name="generateARmode"
                                        title="{{'lang.generateARMode' | translate}}"
                                        placeholder="{{'lang.generateARMode' | translate}}" [(ngModel)]="arMode">
                                        <mat-option value="auto">{{'lang.autoAR' | translate}}</mat-option>
                                        <mat-option value="manual">{{'lang.manualAR' | translate}}</mat-option>
                                        <mat-option value="both">{{'lang.bothAR' | translate}}</mat-option>
                                    </mat-select>
                                </mat-form-field>
                            </div>
                            <div class="col-sm-12">
                                <mat-slide-toggle name="canAddCopies" title="{{'lang.canAddCopies' | translate}}"
                                    id="canAddCopies" color="primary" [(ngModel)]="canAddCopies"
                                    [checked]="canAddCopies">
                                    {{'lang.canAddCopies' | translate}}</mat-slide-toggle>
                            </div>
                        </div>
                        <div class="form-group" *ngIf="action.actionPageId!='reconcile' && action.actionPageId !== 'send_shipping'">
                            <div class="col-sm-12">
                                <plugin-select-search [showLabel]="true" [class]="''"
                                    [label]="intermediateStatusActions.indexOf(action.actionPageId) !== -1 ? ('lang.intermediateStatus' | translate) : ('lang.associatedStatus' | translate)"
                                    [placeholderLabel]="'lang.associatedStatus' | translate"
                                    [formControlSelect]="selectStatusId" [datas]="statuses"
                                    (afterSelected)="action.id_status = selectStatusId.value" style="width:100%;">
                                </plugin-select-search>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-sm-12">
                                <mat-form-field>
                                    <mat-select id="keyword" name="keyword" title="{{'lang.keyword' | translate}}"
                                        placeholder="{{'lang.keyword' | translate}}" [(ngModel)]="action.keyword">
                                        <mat-option *ngFor="let keyword of keywordsList" [value]="keyword.value">
                                            {{keyword.label}}
                                        </mat-option>
                                    </mat-select>
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-sm-12" style="text-align:center;">
                                <mat-slide-toggle name="history" title="{{'lang.actionHistoryDesc' | translate}}"
                                                  id="history" color="primary" [(ngModel)]="action.history"
                                                  [checked]="action.history == 'Y'">
                                    {{'lang.actionHistory' | translate}}</mat-slide-toggle>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-sm-12">
                                <mat-form-field>
                                    <mat-select id="categorieslist" name="categorieslist"
                                        title="{{'lang.chooseCategoryAssociation' | translate}}"
                                        placeholder="{{'lang.chooseCategoryAssociation' | translate}}"
                                        [(ngModel)]="action.actionCategories" multiple required>
                                        <mat-option *ngFor="let category of categoriesList" [value]="category.id" [disabled]="category.id !== 'registeredMail' && action.actionPageGroup === 'registeredMail'">
                                            {{category.label}}
                                        </mat-option>
                                    </mat-select>
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-sm-12" style="text-align:center;">
                                <button mat-raised-button color="primary" type="submit"
                                    [disabled]="!actionsFormUp.form.valid">{{'lang.save' | translate}}</button>
                            </div>
                        </div>
                    </form>
                </mat-card>
            </div>
        </div>
    </mat-sidenav-content>
</mat-sidenav-container>
